Scriptname Bo57:Bo57_ArmorMovingSoundsScript extends ActiveMagicEffect

GlobalVariable    Property Bo57_BellSound       Auto Const
DD:DD_Library     Property libs                 Auto Const								; DD Base API

float             property delay                Auto  Const

Sound[]           Property soundEffectsMoving   Auto  Const

Actor             akActor
InputEnableLayer  UILayer

;---------------------------------------------------------------
;
;---------------------------------------------------------------

Event OnEffectStart(Actor akTarget, Actor akCaster)

  if aktarget == Tools.Player && Bo57_BellSound.getvalueint()
    akActor = akTarget

    UILayer = InputEnableLayer.Create()
    UILayer.EnableSprinting(false)
    UILayer.EnableSneaking(false)
    UILayer.EnableJumping(false)

    ; Animationevents does not fire in power armor
    ; therefore no sound

    RegisterForAnimationEvent(akActor,"FootRight")
    RegisterForAnimationEvent(akActor,"FootLeft")
    RegisterForAnimationEvent(akActor,"JumpUp")
    RegisterForAnimationEvent(akActor,"JumpDown")

    ;/ seems not to trigger
    RegisterForAnimationEvent(akActor,"FootScuffRight")
    RegisterForAnimationEvent(akActor,"FootScuffLeft")
    RegisterForAnimationEvent(akActor,"moveStart")
    RegisterForAnimationEvent(akActor,"moveSlow")
    RegisterForAnimationEvent(akActor,"moveStop")
    RegisterForAnimationEvent(akActor,"EquipStart")
    RegisterForAnimationEvent(akActor,"EquipStop")
    /;
  else
    self.dispel ()
  endif
endEvent

;---------------------------------------------------------------
;
;---------------------------------------------------------------

Event OnEffectFinish (Actor akTarget, Actor akCaster)
   if UILayer
      UILayer.EnableSprinting(True)
      UILayer.EnableSneaking(True)
      UILayer.EnableJumping(True)
      UILayer.Delete ()
   endif
endevent



;---------------------------------------------------------------
;
;---------------------------------------------------------------

Event OnAnimationEvent(ObjectReference akSource, string asEventName)
  If akSource == akActor
    PlaySoundEffects()

    If asEventName != "FootLeft" && asEventName != "FootRight" && asEventName != "JumpUp"
      ; Debug.trace ("F4B ANimationevent " + asEventName)
      PlayDelayedSoundEffects()
    EndIf
  EndIf
EndEvent

;---------------------------------------------------------------
;
;---------------------------------------------------------------
Function PlaySoundEffects()
  Float fWaitTime = Utility.RandomFloat(0.0, delay)
  Utility.Wait(fWaitTime)

  int i = 0
  while i < soundEffectsMoving.Length
    soundEffectsMoving[i].play(akActor)
    i += 1
  endwhile
EndFunction

;---------------------------------------------------------------
;
;---------------------------------------------------------------

Function PlayDelayedSoundEffects()
  Float fWaitTime = Utility.RandomFloat(0.5, 1.0)
  Utility.Wait(fWaitTime)
  PlaySoundEffects()

  fWaitTime = Utility.RandomFloat(0.5, 1.0)
  Utility.Wait(fWaitTime)
  PlaySoundEffects()

  fWaitTime = Utility.RandomFloat(0.5, 1.0)
  Utility.Wait(fWaitTime)
EndFunction

