Scriptname Bo57:Bo57_EffectType_RestrainedLegsScr extends activemagiceffect

Group CommonFunctions
    Bo57:Bo57_MCMandToolsScript   Property Tools          Auto Const
endGroup

Group SAKR
    FormList          Property SAKR_alllegs               Auto Const
endGroup

Group PowerArmorRelated
    Keyword           Property FurnitureTypePowerArmor    Auto Const
    Ammo              Property AmmoFusionCore             Auto Const
endGroup

Actor akActor

; Restrained Legs play effects are handled in DDRC
; sneaking and jumping added back in because:
;   A, Can't sneak and jump but can sprint at full speed?
;   B, It's fucking anoying. Especially when you can get
;      over a tiny curb.
;
; A debuff to stealth and a small debuff to max movement
; speed was added to the enchantment.
;---------------------------------------------------------------
;
;---------------------------------------------------------------
Event OnEffectStart(Actor akTarget, Actor akCaster)
    if aktarget == Tools.Player
        akActor = akTarget
        checkAttire ()
    endIf
endEvent

;---------------------------------------------------------------
;
;---------------------------------------------------------------
Event OnItemEquipped (Form akBaseObject, ObjectReference akReference)
    checkAttire()
endEvent

;---------------------------------------------------------------
;
;---------------------------------------------------------------
Event OnEffectFinish (Actor akTarget, Actor akCaster)

endEvent

;---------------------------------------------------------------
;
;---------------------------------------------------------------
function checkAttire ()
    bool itemUnequipped = false

    if Tools.SAKRInstalled
        int idx = 3
        int end = 43 const

        while (idx < end)
            Actor:WornItem wornValue = akActor.GetWornItem (idx)
            armor attire = wornValue.item as armor

            if Tools.isValidItem ( attire ) && attire.HasKeywordInFormList( SAKR_alllegs )
                itemUnequipped = true
                akActor.unequipitem (attire, false, true)
            endif

            idx += 1
        EndWhile
    else
        Actor:WornItem wornValue = akActor.GetWornItem (3)
        armor attire = wornValue.item as armor

        if Tools.isValidItem ( attire )
            itemUnequipped = true
            akActor.unequipitem (attire)
        endif
    endIf

    If itemUnequipped && akActor == Tools.Player
        Debug.Notification ("Leg restraints prevents dressing up")
    endif
endfunction

; Force Exit Power Armor
Event OnSit(ObjectReference akFurniture)
    if akFurniture.HasKeyword(FurnitureTypePowerArmor) && akFurniture.GetItemCount(AmmoFusionCore)
        Debug.Notification ("Not possible while bound this way")
        akActor.SwitchToPowerArmor(none)
    endIf
endEvent