Scriptname Bo57:Bo57_Gags extends activemagiceffect

Group CommonFunctions
    Bo57:Bo57_MCMandToolsScript   Property Tools          Auto Const Mandatory
endGroup

Actor           akPlayer
ObjectReference kFoodBox
Bool            bDropItems

Event OnEffectStart(Actor akTarget, Actor akCaster)
  if akTarget == Tools.Player && !Tools.FO4NBInstalled
    akPlayer = akTarget

    akPlayer.RemoveItem( Tools.Bo57_FoodKeywords, -1, true, Tools.Bo57_FoodLocker )

    kFoodBox = akPlayer.PlaceAtMe( Tools.Bo57_FoodBox )
    kFoodBox.GetBaseObject().SetWeight( Tools.Bo57_FoodLocker.GetInventoryWeight() )

    Tools.Bo57_FoodBoxAlias.ForceRefTo( kFoodBox )
    akPlayer.AddItem( kFoodBox, 1, true )

    AddInventoryEventFilter( Tools.Bo57_FoodKeywords )
  endIf
endEvent

Event OnEffectFinish (Actor akTarget, Actor akCaster)
  if akTarget == Tools.Player && !Tools.FO4NBInstalled
    Tools.Bo57_FoodLocker.RemoveItem( Tools.Bo57_FoodKeywords, -1, true, akPlayer )

    kFoodBox.GetBaseObject().SetWeight( 0 )

    Tools.Bo57_FoodBoxAlias.ForceRefTo( none )
    akPlayer.RemoveItem( kFoodBox, -1, true )

    RemoveInventoryEventFilter( Tools.Bo57_FoodKeywords )
  endIf
endEvent

Event OnItemAdded (Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
  bDropItems = Tools.Bo57_FoodBoxChoice.Show() == 1

  if !bDropItems && Tools.Bo57_FoodAskToDrop
    akPlayer.RemoveItem( Tools.Bo57_FoodKeywords, -1, true, Tools.Bo57_FoodLocker )
    kFoodBox.GetBaseObject().SetWeight( Tools.Bo57_FoodLocker.GetInventoryWeight() )
  elseIf akSourceContainer
      akPlayer.RemoveItem( akBaseItem, aiItemCount, true, akSourceContainer )
   else
      akPlayer.DropObject( akBaseItem, aiItemCount )
   endif
endEvent