Scriptname Bo57:Bo57_Neural_Stimulation extends activemagiceffect

; Properties
Group ScriptLibsAndTools
  DD:DD_Library                 Property libs                      Auto Const ; DD Base API
  Bo57:Bo57_MCMandToolsScript   Property Tools                     Auto Const ; Some common functions
endGroup

Group DDItemKeywords
  keyword                       Property DD_kw_InventoryItem       Auto Const
endGroup

Group Arousal
  Int                           Property iIntervalMin = 300        Auto Const
  Int                           Property iIntervalMax = 900        Auto Const
endGroup

Group ArmorSlots
  Int                           Property iArmorSlotMin = 3         Auto Const
  Int                           Property iArmorSlotMax = 31        Auto Const
endGroup

Group Orgasms
  Int                           Property iArousalThreshold = 90    Auto Const
  Bool                          Property bAllowOrgasm = false      Auto Const
endGroup

Actor        akPlayer
var[]        srArousal
var[]        srAddiction
var[]        srOrgasm
Int          iIndex
Int          iArousal
Int          iExcitement
Float        fWillpower
Int          iInterval
Int          iLoop
Float        fLoop
Bool[]       bDDSlotOccupied
Armor[]      kDDCompulsion
Float        fDDCompulsion
Int          iDDCompulsionTID    = 10
Float        fPVPKNymphomaniaNow
Float        fPVPKNymphomaniaRoll
Int          iPVPKNymphomaniaTID = 20
Int          iSDSFSanityDamage   = 2


Event OnEffectStart(Actor akTarget, Actor akCaster)
  if akTarget == libs.Player
    akPlayer = akTarget

    Debug.Notification ("The back of your neck tingles momentarily.")

    RegisterForMenuOpenCloseEvent("ContainerMenu")
    AddInventoryEventFilter( DD_kw_InventoryItem )

    if Tools.PVPKInstalled && !akPlayer.HasPerk( Tools.PVPKNymphomania )
      Debug.MessageBox( "This collar is messing with your head! You're so damn horny! You don't know if you'll ever be the same again if you don't get it off soon." )

      fPVPKNymphomaniaRoll = 15.0
      fPVPKNymphomaniaNow  = Utility.GetCurrentGameTime()
      StartTimer( iIntervalMax, iPVPKNymphomaniaTID )
    endIf

    if Tools.FPSAInstalled
      fDDCompulsion = 0.0
      srArousal     = new var[1]
      srAddiction   = new var[1]
      srOrgasm      = new var[1]

      StartTimer( Utility.RandomInt(iIntervalMax, iIntervalMax), iDDCompulsionTID )
    endIf
  endIf
endEvent

Event OnEffectFinish (Actor akTarget, Actor akCaster)
  if Tools.FPSAInstalled
    UnregisterForMenuOpenCloseEvent("ContainerMenu")
    RemoveInventoryEventFilter( DD_kw_InventoryItem )

    CancelTimer( iDDCompulsionTID )
  endIf

  if Tools.PVPKInstalled
    CancelTimer( iPVPKNymphomaniaTID )
  endIf
endEvent


Event OnMenuOpenCloseEvent (string asMenuName, bool abOpening)
  if asMenuName == "ContainerMenu"

    ; #1 - When the container menus opens. Get the armor slots occupied by devious devices on the player
    if abOpening
      kDDCompulsion.Clear()

      iIndex          = iArmorSlotMin
      bDDSlotOccupied = New Bool[29]
      while iIndex < iArmorSlotMax
        bDDSlotOccupied[iIndex] = libs.GetEquippedRenderedDeviceByBipedSlotIndex(akPlayer, iIndex) != None
        iIndex += 1
      endWhile

    ; #3 - When the container menus closes. See if the player s compelled to equip the device
    elseIf kDDCompulsion.length
      iIndex = Utility.RandomInt(0, kDDCompulsion.length - 1)

      if Utility.RandomFloat(0.0, 100.0) < fDDCompulsion
        Debug.Notification ("You just can't help yourself!")
        fDDCompulsion = 0
        libs.EquipDevice( akPlayer, kDDCompulsion[iIndex], libs.GetRenderedDevice(kDDCompulsion[iIndex]), CheckDependencies = True)
      else
        Debug.Notification ("You bite your lip looking at the device in your hands.")
        fDDCompulsion += 0.1
        libs.ArousedMoan( akPlayer, Utility.RandomInt(1,2) )
      endIf

      kDDCompulsion.Clear()
    endIf
  endIf
endEvent

Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
  ; #2 - When a Devious Device is added to the player's inventory. Check to see if it conflicts with one already worn
  ;      If there are no hits add it as a potential item to equip.
  if (akBaseItem As Armor)
    iIndex        = iArmorSlotMin
    int iSlotMask = libs.GetRenderedDevice(akBaseItem As Armor).GetSlotMask()
    bool bGotHit  = false

    while iIndex < iArmorSlotMax && !bGotHit
      bGotHit = bDDSlotOccupied[iIndex] && Math.LogicalAnd(iSlotMask, iIndex)
      iIndex += 1
    endWhile
    
    if !bGotHit
      kDDCompulsion.Add(akBaseItem As Armor)
    endIf
  endIf
endEvent

Event onTimer(int aiTimerID)
  if aiTimerID == iDDCompulsionTID
    Debug.Notification ("Oh GOD! You want to cum so badly!")

    iLoop          = Utility.RandomInt(15,25)
    iArousal       = Tools.FPSAArousal.getValueInt()
    iExcitement    = Math.Ceiling( iArousal / 33.33 )
    iInterval      = Utility.RandomInt(iIntervalMin, iIntervalMax)
    srArousal[0]   = Math.Ceiling( (iInterval - iIntervalMin) / (iIntervalMax - iIntervalMin) * 3 )
    srAddiction[0] = Math.Ceiling( (iInterval - iIntervalMin) / (iIntervalMax - iIntervalMin) * 2 )
    srOrgasm[0]    = (srArousal[0] as Int) * -5

    libs.PlayDDAnimation( akPlayer, libs.DD_CollarHorny01a, iLoop )
    libs.ArousedMoanNoWait( akPlayer, iExcitement )

    Tools.FPSAMain.CallFunction("ModifyArousal", srArousal)
    Tools.FPSAMain.CallFunction("ModifySexLevel", srAddiction)

    fLoop = Utility.RandomFloat(1.0, 3.0)
    Utility.Wait( fLoop )

    iLoop = Utility.RandomInt(1,2)
    if bAllowOrgasm && iArousal > iArousalThreshold
      libs.Orgasm( akPlayer, iLoop )
      Tools.FPSAMain.CallFunction("ModifyArousal", srOrgasm)
    elseIf iArousal > iArousalThreshold * 0.75
      libs.Edge(akPlayer, 1)
    endIf

    fLoop = Utility.RandomFloat(1.0, 3.0)
    Utility.Wait( fLoop )

    libs.DD_SoundPantShort.Play(akPlayer)

    StartTimer( iInterval, iDDCompulsionTID )
  endIf

  if aiTimerID == iPVPKNymphomaniaTID
    fWillpower = Tools.FPSAWillpower.getValue()
    
    Float fBreakingPoint = 2.0 + (2.0 * fWillpower / 100.0)

    if fPVPKNymphomaniaNow + fBreakingPoint > Utility.GetCurrentGameTime()
      StartTimer( iIntervalMax, iPVPKNymphomaniaTID )
    elseIf !akPlayer.HasPerk( Tools.PVPKNymphomania )
      Debug.Notification ("I just... want.... to FUCK.......")

      if Utility.RandomFloat(0.0, 100.0) <= fPVPKNymphomaniaRoll
        Debug.Notification ("I NEED to FUCK someone, anyone,.... anything!")
        akPlayer.DamageValue(Tools.SD_Sanity, iSDSFSanityDamage * 10)
        akPlayer.AddPerk( Tools.PVPKNymphomania )
      else
        fPVPKNymphomaniaRoll = fPVPKNymphomaniaRoll + Utility.RandomFloat(1.0, 10.0)

        Debug.Notification ("NO!")
        akPlayer.DamageValue(Tools.SD_Sanity, iSDSFSanityDamage)
        StartTimer( Math.Ceiling(Utility.RandomInt(iIntervalMin, iIntervalMax)/3), iPVPKNymphomaniaTID )
      endIf
    endIf

  endIf
endEvent
