Scriptname Bo57:Bo57_NipplepiercingScript extends activemagiceffect

Group CommonFunctions
    Bo57:Bo57_MCMandToolsScript   Property Tools          Auto Const
endGroup

Group OptionUnequipTops
    GlobalVariable    Property Bo57_BPiercingNoAtt        Auto Const
endGroup

Group SAKR
    FormList          Property SAKR_alltops               Auto Const
endGroup

Actor akActor

;---------------------------------------------------------------
;
;---------------------------------------------------------------

Event OnEffectStart(Actor akTarget, Actor akCaster)
    if Bo57_BPiercingNoAtt.GetvalueInt ()
        akActor = akTarget          ; try player only for the moment

        checkAttire ()
    else
        self.dispel ()
    endif
endEvent

;---------------------------------------------------------------
;
;---------------------------------------------------------------

Event OnItemEquipped (Form akBaseObject, ObjectReference akReference)
    checkAttire ()
endEvent

;---------------------------------------------------------------
;
;---------------------------------------------------------------

function checkAttire ()
    bool itemUnequipped = false

    if Tools.SAKRInstalled
        int idx = 3
        int end = 43 const

        while (idx < end)
            Actor:WornItem wornValue = akActor.GetWornItem (idx)
            armor attire = wornValue.item as armor

            if Tools.isValidItem ( attire ) && attire.HasKeywordInFormList( SAKR_alltops )
                itemUnequipped = true
                akActor.unequipitem (attire, false, true)
            endif

            idx += 1
        EndWhile
    else
        Actor:WornItem wornValue = akActor.GetWornItem (3)
        armor attire = wornValue.item as armor

        if Tools.isValidItem ( attire )
            itemUnequipped = true
            akActor.unequipitem (attire)
        endif
    endIf

    If itemUnequipped && akActor == Tools.Player
        Debug.Notification ("My piercings will kill me")
    endif
endfunction