Scriptname Bo57:Bo57_StraightJacketScript extends activemagiceffect

Group CommonFunctions
    Bo57:Bo57_MCMandToolsScript   Property Tools          Auto Const
endGroup

Group SAKR
    FormList          Property SAKR_alltops               Auto Const
    FormList          Property SAKR_allbottoms            Auto Const
    FormList          Property SAKR_allskirts             Auto Const
endGroup

Group PowerArmorRelated
    Keyword           Property FurnitureTypePowerArmor    Auto Const
    Ammo              Property AmmoFusionCore             Auto Const
endGroup

Actor akActor

;---------------------------------------------------------------
;
;---------------------------------------------------------------

Event OnEffectStart(Actor akTarget, Actor akCaster)
    akActor = akTarget          ; try player only for the moment

    checkAttire ()
endEvent

;---------------------------------------------------------------
;
;---------------------------------------------------------------

Event OnItemEquipped (Form akBaseObject, ObjectReference akReference)
    checkAttire()
endEvent

;---------------------------------------------------------------
;  30 - Hair on top of head / most hats
;  31 - long hair / flight cap linings / under helmet / hat hoods
;  32 - FaceGenHead (used if your worried about the face clipping through a full face mask)
;  33 - Full outfits - Shoes / Boots
;  34 - Left Hand
;  35 - Right Hand
;  36 - Arm Add-on (Bracelets), Melee weapon on back
;  37 - Torso Layered Add-on (Jackets)
;  38 - Separate Tops (for vanilla outfits that need a second slot to show all armatures-Cage/Spike/ChildofAtom)
;  39 - Leg Add-on (Gun on Hip/Tights/Stockings/Vanilla outfits that need a third slot to show all armatures-ChildofAtom)
;  40 - Separate Pants / Shorts /S kirts
;  41 - Torso armor
;  42 - Left Arm armor
;  43 - Right Arm armor
;  44 - Left Leg armor
;  45 - Right Leg armor
;  46 - Earrings / Masks that cover face / Headbands /(hats/helmets/hoods meant to show all hair)
;  47 - Eyes (Glasses / Eyepatchs)
;  48 - Beard (surgical mask / lower face masks)
;  49 - Mouth (surgical mask / lower face masks)(toothpick / cigarette / joint / cigar / blunt / lip rings)
;  50 - Necklace / Scarfs
;  51 - Ring
;  54 - Backpacks / Capes / Cloaks
;  55 - Belts (utility belts/gunbelts/sword belts) / Gun on hip / Satchels
;  56 - Shoulder Harnesses / Bandoliers
;  57 - Plate Carrier / Cargo Pack Vests(front and back torso) / Capes / Cloaks(alternate backup slot)
;  58 - Body Jewelry (piercings) / Gun on back
;  61 - Off-Hand Accessories (Sword Sheath / Decorative Gun / SOS)
;---------------------------------------------------------------

function checkAttire ()
    if Tools.SAKRInstalled
        bool itemUnequipped = false

        int idx = 3
        int end = 43 const

        while (idx < end)
            Actor:WornItem wornValue = akActor.GetWornItem (idx)
            armor attire = wornValue.item as armor

            if Tools.isValidItem ( attire ) && ( attire.HasKeywordInFormList( SAKR_alltops ) || attire.HasKeywordInFormList( SAKR_allbottoms ) || attire.HasKeywordInFormList( SAKR_allskirts ) || (idx >= 4 && idx <= 8) || (idx >= 10 && idx <= 13) || (idx >= 24 && idx <= 27))
                itemUnequipped = true
                akActor.unequipitem (attire, false, true)
            endif

            idx += 1
        EndWhile


        If itemUnequipped && akActor == Tools.Player
            Debug.Notification ("Harness prevents dressing up")
        endif
    endif
endfunction

; Force Exit Power Armor
Event OnSit(ObjectReference akFurniture)
    if akFurniture.HasKeyword(FurnitureTypePowerArmor) && akFurniture.GetItemCount(AmmoFusionCore)
        Debug.Notification ("Not possible while bound this way")
        akActor.SwitchToPowerArmor(none)
    endIf
endEvent